#! /system/bin/sh
#$Author: qpyin $
#$Date: 2013-7-26 10:21:10  $
#$Rev: 1000 $
#$Rev: 1001 $ 2011-01-06 10:00:00

DEF_FILE="/system/opt/etc/default.iptvsetting"
TAGET_FILE="/params/iptvsetting.properties"
BAK_FILE="/params/iptvsetting.properties-bak"
TAGET_FILE_TMP="/params/iptvsetting.properties-tmp"
FH_REPLACEFILE="/system/opt/etc/replaceline"
LOG_FILE="/data/conf.log"

function setconfig()
{
    FILE=$1
    PARAM=$2
    VALUE=$3

    if [ ! -f $FILE ]; then
        touch $FILE
    fi

    if [ ! -z $VALUE ] && [ `grep "^$PARAM\=" $FILE` ]; then
        busybox sed -e "s#^$PARAM\=.*#$PARAM=$VALUE#" -i $FILE
    fi
}

#Get parameter value from config file
getconfig()
{
    FILE="$1"
    PARAM="$2"
    
    VALUE=`grep "^$PARAM\=" $FILE | busybox sed "s/^$PARAM\=//"|busybox cut -d ' ' -f 1`
    echo "$VALUE"
}

EchoLog(){
   logsz=`ls -l $LOG_FILE | busybox awk '{print $4}'`
   if [ $logsz -gt 10485760 ]; then
      echo "log size is $logsz"
      rm $LOG_FILE
      touch $LOG_FILE
   fi
   echo "$1" >> $LOG_FILE
}

#Change param name in "/params/iptvsetting.properties" file
UpConfig()
{
    VER=`getconfig $TAGET_FILE "config.version"`
    OLDVER=`getconfig $DEF_FILE "config.version"`
    echo "[SHELL] UpConfig, oldver=$OLDVER"
    
    if [ -z $VER ];then
        VER=0
    fi
    if [ -z $OLDVER ];then
        OLDVER=0
    fi
    if [ $OLDVER -ne $VER ];then
    EchoLog "UpConfig start `busybox diff $TAGET_FILE $DEF_FILE`"
        cp $DEF_FILE $TAGET_FILE_TMP
        if [ -f $FH_REPLACEFILE ];then
            while read NEWLINE || [ -n "$NEWLINE" ]
            do
                if [ "$NEWLINE" == "" ];then
                    continue;
                fi
                NEWVALUE=`busybox grep "$NEWLINE=" $DEF_FILE | busybox cut -d = -f2`
                echo "write $NEWLINE --- $NEWVALUE to cfg file"
                setconfig $TAGET_FILE "$NEWLINE" "$NEWVALUE"
            done<$FH_REPLACEFILE
        fi
        while read LINE || [ -n "$LINE" ]
        do
            FIRST=`echo "$LINE" | busybox cut -c1`
            if [ "$FIRST" == "#" ]||[ "$FIRST" == "[" ];then
                continue;
            fi
            PARAM=`echo "$LINE" | busybox cut -d = -f1`
            VALUE=`echo "$LINE" | busybox cut -d = -f2`
            if [ "$PARAM" != "config.version" ] && [ "$PARAM" != "version.hardware" ] && [ "$PARAM" != "device.stbmodel" ];then
                busybox sed -e "s#^$PARAM=.*#$PARAM=$VALUE#" -i $TAGET_FILE_TMP
            fi
        done<$TAGET_FILE
        cp $TAGET_FILE_TMP $TAGET_FILE
        chmod 666 $TAGET_FILE
        rm -r $TAGET_FILE_TMP
        rm -r $BAK_FILE
        cp $TAGET_FILE $BAK_FILE
    EchoLog "UpConfig end `busybox diff $TAGET_FILE $DEF_FILE`"
    fi
}

if [ -f $TAGET_FILE ];then
    TAGET_CRC=`busybox awk  '!/^$/{x++}END{print  x}' $TAGET_FILE`
    if [ $TAGET_CRC -gt 10 ];then
        UpConfig
    fi
fi

serialno=`busybox awk -F = '$1=="device.stbid"{print $2}' ${TAGET_FILE}`
SN=`getprop ro.serialno`
HWMAC=`getprop ro.mac`
if [ -z $SN ] && [ ! -z $serialno ]; then
    echo "write serialno $serialno"
    #echo "device.stbid=$serialno" > $STBID_FILE
    /system/bin/opt/etc/write_stbid.sh $serialno   
    setprop ro.serialno $serialno

    MAC=`busybox grep "network.lan.mac=" $TAGET_FILE | busybox cut -d = -f2`
    if [ "$MAC" != "$HWMAC" ] && [ ! -z $MAC ]; then
       /system/bin/opt/etc/write_mac_guest.sh $MAC
       setprop ro.mac $MAC
    fi
fi
BUSUSR=`getprop "persist.business.username"`
NETTYPE=`getprop "persist.network.type"`
if [ -f $TAGET_FILE ]; then
    NETTYPE=`busybox grep "network.type=" $TAGET_FILE | busybox cut -d = -f2`
    PPPUSR=`busybox grep "network.pppoe.username=" $TAGET_FILE | busybox cut -d = -f2`
    PPPWD=`busybox grep "network.pppoe.password=" $TAGET_FILE | busybox cut -d = -f2`
    DHCPUSR=`busybox grep "network.dhcp.username=" $TAGET_FILE | busybox cut -d = -f2`
    DHCPPWD=`busybox grep "network.dhcp.password=" $TAGET_FILE | busybox cut -d = -f2`
    DHCPCTC=`busybox grep "network.dhcp.ctc22=" $TAGET_FILE | busybox cut -d = -f2`
    DHCPOPT125=`busybox grep "network.option125.enable=" $TAGET_FILE | busybox cut -d = -f2`
    BUSUSR=`busybox grep "business.username=" $TAGET_FILE | busybox cut -d = -f2`
    BUSPWD=`busybox grep "business.password=" $TAGET_FILE | busybox cut -d = -f2`
    ZEROCFG=`busybox grep "other.isFirstUse=" $TAGET_FILE | busybox cut -d = -f2`
if [ ! -z $NETTYPE ]; then
    setprop "persist.network.type" "$NETTYPE"
fi
if [ ! -z $PPPWD ]; then
    setprop "persist.pppoe.username" "$PPPUSR"
    setprop "persist.pppoe.password" "$PPPWD"
fi
if [ ! -z $DHCPPWD ]; then
    setprop "persist.dhcp.username" "$DHCPUSR"
    setprop "persist.dhcp.password" "$DHCPPWD"
    setprop "persist.dhcp.ctc22" "$DHCPCTC"
    setprop "persist.dhcp.option125" "$DHCPOPT125"
fi
if [ ! -z $BUSPWD ]; then
    setprop "persist.business.username" "$BUSUSR"
    setprop "persist.business.password" "$BUSPWD"
    setprop "persist.other.isFirstUse" "$ZEROCFG"
fi
fi

if [ ! -f $BAK_FILE  ]; then
    echo "cp $TAGET_FILE to $BAK_FILE"
    cp $TAGET_FILE $BAK_FILE
fi

DEF_CRC=`busybox awk  '!/^$/{x++}END{print  x}' $DEF_FILE`
TAGET_CRC=`busybox awk  '!/^$/{x++}END{print  x}' $TAGET_FILE`
TAGET_MD5=`busybox md5sum $TAGET_FILE | busybox awk '{print $1}'`
BAK_MD5=`busybox md5sum $BAK_FILE | busybox awk '{print $1}'`
MAC=`busybox grep "network.lan.mac=" $TAGET_FILE | busybox cut -d = -f2`
STBID=`busybox grep "device.stbid=" $TAGET_FILE | busybox cut -d = -f2`
echo "DEF_CRC=$DEF_CRC"
echo "TAGET_CRC=$TAGET_CRC"
echo "TAGET_MD5=$TAGET_MD5"
echo "BAK_MD5=$BAK_MD5"
echo "MAC=$MAC"
echo "STBID=$STBID"

if [ "$DEF_CRC" = "$TAGET_CRC" ] && [ ! -z $MAC ] && [ ! -z $STBID ]; then
    if [ "$TAGET_MD5" != "$BAK_MD5" ]; then
        echo "cp $TAGET_FILE to $BAK_FILE"
        cp $TAGET_FILE $BAK_FILE
    fi
else
    echo "cp $BAK_FILE to $TAGET_FILE"
    EchoLog " bak recovery `busybox diff $TAGET_FILE $DEF_FILE`"
    cp $BAK_FILE $TAGET_FILE
    chmod 666 $TAGET_FILE
fi

MAC=`busybox grep "network.lan.mac=" $TAGET_FILE | busybox cut -d = -f2`
STBID=`busybox grep "device.stbid=" $TAGET_FILE | busybox cut -d = -f2`
DEF_CRC=`busybox awk  '!/^$/{x++}END{print  x}' $DEF_FILE`
TAGET_CRC=`busybox awk  '!/^$/{x++}END{print  x}' $TAGET_FILE`
#STBID_BAK=`busybox grep "device.stbid=" $STBID_FILE | busybox cut -d = -f2`
SN=`getprop ro.serialno`
HWMAC=`getprop ro.mac`

echo "*******************************"
echo "ro.mac=$HWMAC"
echo "ro.serialno=$SN"
echo "network.lan.mac=$MAC"
echo "device.stbid=$STBID"
echo "DEF_CRC=$DEF_CRC"
echo "TAGET_CRC=$TAGET_CRC"

if [ -z $STBID ] || [ -z $MAC ] || [ "$DEF_CRC" != "$TAGET_CRC" ]; then
    NETTYPE=`getprop "persist.network.type"`
    PPPUSR=`getprop "persist.pppoe.username"`
    PPPWD=`getprop "persist.pppoe.password"`
    DHCPUSR=`getprop "persist.dhcp.username"`
    DHCPPWD=`getprop "persist.dhcp.password"`
    DHCPCTC=`getprop "persist.dhcp.ctc22"`
    DHCPOPT125=`getprop "persist.dhcp.option125"`
    BUSUSR=`getprop "persist.business.username"`
    BUSPWD=`getprop "persist.business.password"`
    ZEROCFG=`getprop "persist.other.isFirstUse"`
    EchoLog "recovery start `busybox diff $TAGET_FILE $DEF_FILE`"
    EchoLog "$NETTYPE--$PPPUSR--$PPPWD--$DHCPUSR--$DHCPPWD--$DHCPCTC--$DHCPOPT125--$BUSUSR--$BUSPWD--$ZEROCFG"
    echo "cp $DEF_FILE $TAGET_FILE"

    cp $DEF_FILE $TAGET_FILE
    rm $BAK_FILE
    chmod 666 $TAGET_FILE
    if [ ! -z $HWMAC ];then
        setconfig $TAGET_FILE "network.lan.mac" "$HWMAC"
    else
        if [ ! -z $MAC ]; then       
           setconfig $TAGET_FILE "network.lan.mac" "$MAC"
        fi     
    fi
    
    if [ ! -z $SN ]; then
        setconfig $TAGET_FILE "device.stbid" "$SN"
    else
        if [ ! -z $STBID ]; then
           setconfig $TAGET_FILE "device.stbid" "$STBID"
        fi
    fi
    setconfig $TAGET_FILE "network.type" "$NETTYPE"
    setconfig $TAGET_FILE "network.pppoe.username" "$PPPUSR"
    setconfig $TAGET_FILE "network.pppoe.password" "$PPPWD"
    setconfig $TAGET_FILE "network.dhcp.username" "$DHCPUSR"
    setconfig $TAGET_FILE "network.dhcp.password" "$DHCPPWD"
    setconfig $TAGET_FILE "network.dhcp.ctc22" "$DHCPCTC"
    setconfig $TAGET_FILE "network.option125.enable" "$DHCPOPT125"
    setconfig $TAGET_FILE "business.username" "$BUSUSR"
    setconfig $TAGET_FILE "business.password" "$BUSPWD"
    setconfig $TAGET_FILE "other.isFirstUse" "$ZEROCFG"
    cp $TAGET_FILE $BAK_FILE
    EchoLog "recovery end `busybox diff $TAGET_FILE $DEF_FILE`"
fi
if [ ! -z $HWMAC ] && [ "$MAC" != "$HWMAC" ]; then
    setconfig $TAGET_FILE "network.lan.mac" "$HWMAC"
    EchoLog "write devinf mac $HWMAC to cfg, src mac $MAC"
fi
if [ ! -z $SN ] && [ "$STBID" != "$SN" ]; then
    setconfig $TAGET_FILE "device.stbid" "$SN"
    EchoLog "write devinf stbid $SN to cfg, src stbid $STBID"
fi
function setflashsizeprop()
{
FLASH_SIZE=`cat /proc/partitions|grep -w "mmcblk0"|busybox awk '{print $3}'`
FLASH_SIZE=`busybox expr ${FLASH_SIZE} / 1024 / 1024`
if [ $FLASH_SIZE -gt 4 ]; then
   setprop ro.total.flash "8G"
   setprop android.os.Build.FINGERPRINT "RAM 1G/Flash 8G EMMC"
else
   setprop ro.total.flash "4G"
   setprop android.os.Build.FINGERPRINT "RAM 1G/Flash 4G EMMC"
fi
}

setflashsizeprop