#!/system/bin/sh

Add_IPTV_Route()
{
	local GW_A=$1
	local DEV_A=$2
	local GW_B=$3
	local DEV_B=$4

	File_RouteTable=/params/route_table
	if [ ! -e $File_RouteTable ]; then
		touch $File_RouteTable
	fi
	#//. /opt/etc/setenv.sh
	#///opt/bin/httpRouteUpdater "http://116.228.215.9:8088/etvbss/servlet/" "RouteServlet" "AutoCheckServlet"

    local tailtest=`tail -n 1 $File_RouteTable`
    if [ -n "$tailtest" ]; then
        echo "" >> $File_RouteTable
    fi

	vlan=`awk -F = '$1=="# vlan_id"{print $2}' "/params/route_table"`
	echo "vlan is $vlan " 
	if [ -z "$vlan" ]; then
		vlan=85
	fi
	if [ "$vlan" != "${DEV_B##*.}" ]; then
	  /system/opt/etc/udhcpc-opt125after.script repeat $DEV_B $vlan
	  exit 0
	fi

	while route del default dev $DEV_A ; do
		:
	done
	while route del default dev $DEV_B ; do
		:
	done
	#route add -net 228.67.43.91 netmask 255.255.255.255 gw $GW_B dev $DEV_B
	
	while read LINE
	do
		if `echo $LINE | grep "^#" > /dev/null` ; then
			continue;
		fi
		local NET=`echo "$LINE" | awk '{print $1}'`
		local NETMASK=`echo "$LINE" | awk '{print $2}'`
		local PLANE=`echo "$LINE" | awk '{print $3}'`
		if [ "$PLANE" == "A" ]
		then
		 #echo "route add -net $NET netmask $NETMASK gw $GW_A dev $DEV_A"
			route add -net $NET netmask $NETMASK gw $GW_A dev $DEV_A
		else
		 #echo "route add -net $NET netmask $NETMASK gw $GW_B dev $DEV_B"
			route add -net $NET netmask $NETMASK gw $GW_B dev $DEV_B
		fi
	done < $File_RouteTable

	route add default gw $GW_A dev $DEV_A
}

Del_IPTV_Route()
{
	RouteTable=`busybox route`
	
	oldtable=/params/oldtable
	if [ ! -e $oldtable ]; then
		touch $oldtable
	fi
	echo "$RouteTable" > /params/oldtable
	
	#while busybox route del default dev $DEV_A ; do
	#	:
	#done
	#while busybox route del default dev $DEV_B ; do
	#	:
	#done
	
	while read LINE
	do
		local Destination=`echo "$LINE" | awk '{print $1}'`
		local Gateway=`echo "$LINE" | awk '{print $2}'`
		local Genmask=`echo "$LINE" | awk '{print $3}'`
		local Iface=`echo "$LINE" | awk '{print $8}'`
		if [ "$Destination" == "Destination" -o "$Destination" == "Kernel" ]; then
			continue;
		fi
		if [ "$Destination" == "default" -o "$Gateway" == "*" ]; then
			continue;
		fi
		#echo "busybox route del -net $Destination netmask $Genmask $Iface"
		busybox route del -net $Destination netmask $Genmask $Iface
	done < $oldtable
	
	if [ -e $oldtable ]; then
		rm $oldtable
	fi
}

vlanid=`awk -F = '$1=="# vlan_id"{print $2}' "/params/route_table"`
DEV_A=`getprop net.dev`
DEV_B=`getprop net.dev.b`
GW_A=`getprop dhcp.$DEV_A.gateway`
GW_B=`getprop dhcp.$DEV_B.gateway`

echo "DEV_A is $DEV_A , DEV_B is $DEV_B ,GW_A is $GW_A ,GW_B is $GW_B"
echo "deleting routers"
Del_IPTV_Route
echo "adding routers"
Add_IPTV_Route "$GW_A" "$DEV_A" "$GW_B" "$DEV_B"
