#!/system/bin/sh
#$Author: zhangjian $
#$Date: 2017-07-03  $
#$Rev: 1000 
#$Rev: 1000
# 
echo "One Key Collect"

devMac=$(busybox ifconfig | grep "HWaddr" | busybox awk '{print $5}' | busybox sed "s/://g")
startupDirName="STBLogInfo_"$devMac"_Startup"
startupDirPath="/sdcard/$startupDirName"
sdcardDir="/sdcard"
startupFlag="/params/onekeystartup"
dirName="STBLogInfo_"$devMac"_"`date '+%Y%m%d%H%M%S'`

hwVersion=`getprop android.os.Build.BOARD`
if [ $hwVersion == "HISILICON-Hi3798M" ];then
    usbDir=$(df | grep "/mnt/sd" | busybox awk '{print $1}')
elif [ $hwVersion == "AMLOGIC_S905L" ];then
    usbDir=$(df | grep "/storage/external_storage/sda" | busybox awk '{print $1}')
elif [ $hwVersion == "MSTAR-9280" ];then
    usbDir=$(df | grep "/mnt/usb/sda" | busybox awk '{print $1}')
else
    usbDir=$(df | grep "/mnt/sd" | busybox awk '{print $1}')
fi

usbDirValue=$(echo $usbDir)

dirPath="$usbDir/$dirName"

echo "$hwVersion, $usbDir, $devMac"

stop(){
    echo "Stop collect info......"

    if [ -d $startupDirPath ];then
        rm -rf $startupDirPath

        if [ -f  $startupFlag ];then
            rm -rf $startupFlag
        fi
    fi

    PID=$(ps | grep "tcpdump" | busybox awk '{print $2}')
    echo "tcpdump=$PID"
    if [ ! $PID ];then
        echo "tcpdump is not exist"
    else
        kill $PID
    fi

    PID=$(ps | grep "logcat" | busybox awk '{print $2}')
    echo "logcat=$PID"
    if [ ! $PID ];then
        echo "logcat is not exist"
    else
        kill $PID
    fi

    PID=$(ps | grep "onekeycollect" | busybox awk '{print $2}')
    echo "onekeycollect=$PID"
    if [ ! $PID ];then
        echo "onekeycollect is not exist"
    else
        kill $PID
    fi
}

start(){
    echo "Start collect info......"

    usbMounted=0
    if [[ "$usbDirValue" != "" ]]; then
        echo "USB device is mounted to $usbDir"
        usbMounted=1    
    else
        echo "No USB device is mounted"
        usbMounted=0
    fi
    
    if [ $usbMounted -eq 1 ];then
        mkdir $dirPath
        STBDevInfo="STBDeviceInfo"
        mkdir "$dirPath/$STBDevInfo"
        
        STBDevInfoTar=$dirPath/STBDeviceInfo.tar.gz
        
        dmesg > $dirPath/STBDmesg.txt
        getprop > $dirPath/GetProp.txt
        
        dropbox="/data/system/dropbox"
        tombstones="/data/tombstones"
        anr="/data/anr"
        datadata="/data/data"
        
        version="/system/opt/etc/version"
        buildprop="/system/build.prop"
        iptvsettingprop="/params/iptvsetting.properties"
        defaultiptvsetting="/system/opt/etc/default.iptvsetting"
        fhversion="/system/fhversion"
        
        cp -rp $dropbox      $dirPath/$STBDevInfo
        cp -rp $tombstones   $dirPath/$STBDevInfo
        cp -rp $anr          $dirPath/$STBDevInfo
        cp -rp $datadata     $dirPath/$STBDevInfo
        cp -rp $version      $dirPath/$STBDevInfo
        cp -rp $buildprop    $dirPath/$STBDevInfo
        cp -rp $iptvsettingprop  $dirPath/$STBDevInfo
        cp -rp $defaultiptvsetting  $dirPath/$STBDevInfo
        cp -rp $fhversion  $dirPath/$STBDevInfo

        chmod -R 777 $dirPath/$STBDevInfo
        cd $dirPath
        
        if [ $hwVersion == "AMLOGIC_S905L" ];then
            echo "The command of tar in AMLOGIC 905L is wrong."
        else
            busybox tar cvzf  $STBDevInfoTar  $STBDevInfo
            rm -rf $STBDevInfo
        fi
        
        tcpdump -i eth0 -w  $dirPath/STBCap.cap &
        logcat -v time > $dirPath/STBLog.txt &
        
        dirSize=1
        while [ $dirSize -le 4194304 ]
        do
            if [[ "$usbDirValue" == "" ]];then 
                break
            fi
            
            echo "============`date '+%Y%m%d%H%M%S'`===============" >> $dirPath/STBRoute.txt
            busybox route -n >> $dirPath/STBRoute.txt
            
            echo "============`date '+%Y%m%d%H%M%S'`===============" >> $dirPath/STBArp.txt
            busybox arp -a >> $dirPath/STBArp.txt
            
            echo "============`date '+%Y%m%d%H%M%S'`===============" >> $dirPath/STBPs.txt
            ps >> $dirPath/STBPs.txt
            
            echo "============`date '+%Y%m%d%H%M%S'`===============" >> $dirPath/STBTop.txt
            top -n 1 >> $dirPath/STBTop.txt
            
            echo "============`date '+%Y%m%d%H%M%S'`===============" >> $dirPath/STBIfconfig.txt
            busybox ifconfig >> $dirPath/STBIfconfig.txt
            
            sleep 5
            
            dirSize=$(du -s $dirPath | busybox awk '{print $1}')
            echo $dirSize
        done
    
        sync    
        PID=$(ps | grep "tcpdump" | busybox awk '{print $2}')
        if [ ! $PID ];then
            echo "tcpdump is not exist"
        else
            kill $PID
        fi
        
        PID=$(ps | grep "logcat" | busybox awk '{print $2}')
        if [ ! $PID ];then
            echo "logcat is not exist"
        else
            kill $PID
        fi
    fi
    
    exit 0
}

startup(){
    ONEKEYCTON=`getprop persist.sys.onekeyct`
    case $ONEKEYCTON in
    "1")
        echo "one key collect startup"
        
        flag=1
        while [ $flag==1 ]
        do
            if [ ! -d $sdcardDir ];then
                sleep 1
            else
                break
            fi
        done

        if [ -d $startupDirPath ];then
            if [ -f  $startupFlag ];then
                echo "There has startup message"
                if [[ "$usbDirValue" != "" ]];then
                    cp -a $startupDirPath  $usbDir
                    sync
                fi
                return 0
            fi
        else
            mkdir $startupDirPath
        fi
           
        dmesg > $startupDirPath/startup.txt
        tcpdump -i eth0 -w  $startupDirPath/STBCap.cap &
        logcat -v time > $startupDirPath/STBLog.txt &
        
        echo "startup message collect" >> $startupFlag
        
        dirSize=1
        i=1
        while [[ i -lt 10 ]]
        do
            dirSize=$(du -s $startupDirPath | busybox awk '{print $1}')
            i=$((i+1))
            echo $i,logsize:$dirSize
            if [[ $dirSize -lt 40960 ]];then
                echo "============`date '+%Y%m%d%H%M%S'`===============" >> $startupDirPath/STBRoute.txt
                busybox route -n >> $startupDirPath/STBRoute.txt
            
                echo "============`date '+%Y%m%d%H%M%S'`===============" >> $startupDirPath/STBArp.txt
                busybox arp -a >> $startupDirPath/STBArp.txt
            
                echo "============`date '+%Y%m%d%H%M%S'`===============" >> $startupDirPath/STBPs.txt
                ps >> $startupDirPath/STBPs.txt
            
                echo "============`date '+%Y%m%d%H%M%S'`===============" >> $startupDirPath/STBTop.txt
                top -n 1 >> $startupDirPath/STBTop.txt
            
                echo "============`date '+%Y%m%d%H%M%S'`===============" >> $startupDirPath/STBIfconfig.txt
                busybox ifconfig >> $startupDirPath/STBIfconfig.txt
            
                sleep 5
            fi
        done
        
        PID=$(ps | grep "tcpdump" | busybox awk '{print $2}')
        if [ ! $PID ];then
            echo "tcpdump is not exist"
        else
            kill $PID
        fi
            
        PID=$(ps | grep "logcat" | busybox awk '{print $2}')
        if [ ! $PID ];then
            echo "logcat is not exist"
        else
            kill $PID
        fi
            
        if [[ "$usbDirValue" != "" ]];then
            cp -a $startupDirPath  $usbDir
            sync
        fi
    ;;
    *)
    ;;
    esac
}

startup

case "$1" in      
  'start')  
    start  
   ;;  
  'stop')  
    stop  
    ;;  
  'startup')
    startup
    ;;
  *)  
    echo $"Usage: $0 {start|stop|startup}"  
    ;;
esac
